// includes, system
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

// includes, project
#include <cufft.h>
#include <cutil_inline.h>
#include "C:\Program Files\National Instruments\LabVIEW 8.6\cintools\extcode.h"





__declspec(dllexport) void Window_For_FFT(unsigned int Data_In, unsigned int Filter_Value);
static __global__ void window(float *Data_In, float *Filter_Value , int, int);





// The filter size is assumed to be a number smaller than the signal size
#define SIGNAL_SIZE        1024*1000
#define FILTER_SIZE        1024


void Window_For_FFT(float *Data_In, float *Filter_Value)
{

	dim3 dimGrid;
	dim3 dimBlock;

	dimBlock.x = 512;
	dimBlock.y = 1;

	dimGrid.x = 2;
	dimGrid.y = 1000;
	
    window<<<dimGrid, dimBlock>>>(Data_In, Filter_Value, 1000, 1024);

}





// Fenster fr FFT berechnen
__global__ void window(float *waveform, float *coeff, int n_waveform, int number_of_coefficients)
{   

	int tidx = threadIdx.x + blockIdx.x*blockDim.x;
	int tidy = threadIdx.y + blockIdx.y*blockDim.y;
  
	if( tidx >= number_of_coefficients )
	{
		return;
	}
	if( tidy >= n_waveform )
	{
		return;
	}

	waveform[tidy * number_of_coefficients + tidx] = waveform[tidy * number_of_coefficients + tidx] * coeff[tidx];
	
} 



